--DLG2EU  MS-WORD dialogs to Euphoria TRANSLATOR
-- by Mike Raley 1/1/98
-- Converts Macrode.exe Dialogs to Euphoria Win32lib code
-- Will auto-create empty procedures for all pushbuttons
-- run command line "ex DLG2EU macrofile.edl outfile.exw" 
-- ver 1.0  limited to ListBoxes and OK,CANCEL, or Pushbuttons.
-- ver 1.2 Added Window_Params(), Textbox, Combo, Option, Checkbox
-- grouped related blocks of main code into procedures.
include file.e
include get.e
----------------------Declarations ------------------------------------
	object edlfile,outfile,sequil,ctitle
	sequence cmdfil,sequio,eucode,Procode
	atom edf,odf,buttn_count,bfield,bmax 
	atom Line_Count,ListC,found_buttn
	atom boxtype
eucode={}
Procode={}
boxtype=0 
--------------------------------------------------------------------------
procedure Pubs() -- insert PushButtons 
buttn_count=0
for L=1 to Line_Count do
   sequil=sequio[L]
   found_buttn= match("Button", sequil) 
   if found_buttn>0 and not match("Option",sequil) then 
               buttn_count=buttn_count+1
 	    puts (odf, "constant Button")
	    print (odf,  buttn_count)
	    puts (odf, " = create ( PushButton,")
	  -- parse the line for fields by end title
	  -- check  for the text title
              bfield=match("\"",sequil)
              bmax=length(sequil)-1
	   if bfield then --control text found at end of line
     	         ctitle=sequil[bfield..bmax]
--if text  not found check the button type for text
	         else ctitle="\""&sequil[2..found_buttn-1]&"\"" 
	         bfield=length(sequil)+2
	   end if 
	   eucode=sequil[found_buttn+6..bfield-3] --control position 
	
	   puts (odf, ctitle)
	   --save something for the auto procedure coder
              Procode=append(Procode, buttn_count&ctitle)
	   puts (odf,",Veuwin,") -- Veuwin is always the Owner 
	   puts (odf, eucode)		
              puts (odf, ")\n")
   end if
end for
end procedure
-----------------------------------------------------------------------
procedure Lboxers() -- insert listboxes, textbox, comboboxes
buttn_count=0
ListC=0
for L=1 to Line_Count do
bmax=0   
sequil=sequio[L]
   found_buttn= match("Box", sequil)
   if found_buttn>0 then  
	ctitle=sequil[2..found_buttn-1]
	     if match("Check", sequil) then
		 ctitle=sequil[2..found_buttn+2]
	    end if		
	boxtype=6 -- when counting the comma's
	-- Listbox and combo have an extra component
	if match("Text", sequil) then ctitle="CText"
		 boxtype=6 
	end if 
	    buttn_count=buttn_count+1
 	    puts (odf, "constant "&ctitle)
	    print (odf,  buttn_count)
	    puts (odf, " = create ( "&ctitle&",")
	  -- parse the line for fields discard end text
	 for c=1 to length(sequil) do --counting commas
 		bfield=match(",", sequil[c..c+1])
		ListC=c
		if bfield then bmax=bmax+1 end if  
		if bmax>boxtype then exit end if
	end for 
	   eucode=sequil[found_buttn+3..ListC-(1*(boxtype=5))]
	   puts (odf, "\"\"")-- "" in place of control text
	   puts (odf,",Veuwin,")-- Veuwin is always the owner
	   puts (odf, eucode)		
              puts (odf, ")\n  --") -- Comment field
  	   puts (odf, sequil[ListC+1..length(sequil)])
	   puts(odf, "\n")
   end if
end for
end procedure
----------------------------------------------------------------------------
procedure Options() -- insert  OptionButtons 
buttn_count=0
for L=1 to Line_Count do
   sequil=sequio[L]
   found_buttn= match("OptionButton", sequil) 
   if found_buttn>0  then 
               buttn_count=buttn_count+1
 	    puts (odf, "constant Radio")
	    print (odf,  buttn_count)
	    puts (odf, " = create ( Radio,")
	  -- parse the line for fields by end title
	  -- check  for the text title
              bfield=match("\"",sequil)
              bmax=length(sequil)-1
	   if bfield then --control text found at end of line
     	         ctitle=sequil[bfield..bmax]
	   end if 
	   eucode=sequil[found_buttn+12..bfield-3] --control position 
	
	   puts (odf, ctitle)
	   puts (odf,",Veuwin,") -- Veuwin is always the Owner 
	   puts (odf, eucode)		
              puts (odf, ")\n")
   end if
end for
end procedure
-----------------------------------------------------------------------
procedure Auto_Pubs()
Line_Count=length(Procode)
for L=1 to Line_Count do
	found_buttn=Procode[L][1]   --button id#
	ctitle=Procode[L][3..length(Procode[L])]  --text for comments
	puts(odf,"procedure onClick_button")
	print (odf,found_buttn)
	puts(odf,"()")
	puts(odf, "   --"&ctitle&"\n") 
	puts(odf, "end procedure")
           puts(odf,"\n")
	puts(odf,"onClick [Button")
	print (odf, found_buttn)
	puts(odf,"] = routine_id(\"onClick_button")
	print (odf,found_buttn)
	puts(odf,"\")\n")
	puts(odf,"\n")
end for
end procedure
----------------------------------------------------------------------------
procedure Window_Param()
   buttn_count=0
 -- the UserDialog must be on the first line or we use a default  
   sequil=sequio[1]
   found_buttn= match("UserDialog", sequil)
   if found_buttn>0 then 
               puts (odf, "constant Veuwin=") --My name is Veuwin
	    puts (odf, " create ( Window,")
	   -- check  for the text title
              bfield=match("\"",sequil)
              bmax=length(sequil)-1
	   ctitle=sequil[bfield..bmax]
	   eucode=sequil[found_buttn+11..bfield-3] --control position 
	   puts (odf, ctitle)
	   puts (odf,",0, 10,10,") -- Veuwin id#0 , position defaults top left
	   puts (odf, eucode)		
              puts (odf, ")\n")  
  else  puts(odf,"constant Veuwin=  create( Window, \"My Title\", 0, 10, 10, 400, 320 )\n")
end if
end procedure
-------------------------------------------------------------------------------------- 
procedure Open_Dialog()
cmdfil = command_line()
  if length(cmdfil)=2 then 
	puts(1, "arguements not found. Please provide;" )
	ctitle={}
	while 1 do 
	    puts(1, "Dialog file?\n")      
               ctitle = gets(0)  -- read standard input (keyboard)
	 ctitle = ctitle[1..length(ctitle)-1]
	    if length(ctitle)>5 then exit end if
	end while  
	cmdfil=append(cmdfil,ctitle)
	while 1 do 
	   puts(1, "Output file?\n")      
	   ctitle = gets(0)  -- read standard input (keyboard)
	 ctitle = ctitle[1..length(ctitle)-1]
	    if length(ctitle)>5 then exit end if 
	end while  
	cmdfil=append(cmdfil,ctitle) 
	ctitle={}
    else if length(cmdfil)=3 then puts(1, "Need input!")
	abort(1) end if
   end if
edlfile=cmdfil[3]   -- this is the macro defined list
outfile=cmdfil[4]  -- this will be the exw file to make
edf=open(edlfile,"r")
  if edf=-1 then 
    puts(1,"\nmacro file not found or file error\n")
    abort(1)
  end if
end procedure
---------------------------------------------------------------------------------
procedure Read_Dialog()
sequio={}
Line_Count=0
while 1 do
      sequil=gets(edf)
	  if atom(sequil) then exit
	end if 
       sequio=append(sequio,sequil)
Line_Count=Line_Count+1
end while
close(edf)
end procedure
-----------------------------------------------------------------------------------
procedure Add_Headers()
odf=open(outfile,"w")  --this should be a .exw file
--                                 Plug-in       headers 
puts (odf,"-- Euphoria stand alone generated file\n")
puts (odf,"-- Made from Macrode Dialog2Eu translator\n")
puts (odf,"-- by Michael J. Raley < mjronline@it-works.com >\n")
puts (odf,"--dtg: ")
print(odf,date())
puts(odf,"--\n")
puts (odf,"include win32lib.ew --from David Cuny's code\n")
puts (odf,"--\n")
puts (odf,"--\n")
end procedure
----------------------------***Main Structure***--------------------------------
Open_Dialog()	--open edl (input)
Read_Dialog()	--read and close edl 
Add_Headers()	-- open odf (output) 
Window_Param()	--Window title and size
Pubs()		-- check all push buttons
Lboxers()		--check for Lists, combo boxes, textboxes 
Options()	--check for option buttons nest in groups?
puts(odf,"\n\n\n") -- add some blank lines
Auto_Pubs()	--generate Procedures
puts (odf,"WinMain(Veuwin)\n")--call to Windows 
close (odf) 		-- Finis